(function() {

    var MindTouch = {};
    MindTouch.SITE_URL = "https://success.mindtouch.com";
    MindTouch.CUSTOMER_ID = '';
    MindTouch.WIDGET_NAME = 'MT-activity-custom';

    var j$ = this.$;

    // sets event handlers
    var GeniusLink = {};

    GeniusLink.init = function() {
        GeniusLink.customerHistory(MindTouch.CUSTOMER_ID);
    };
    
    GeniusLink.customerHistory = function(customerId) {
        var $results = j$('.mt-history');

        if (!customerId) {
            $results.text('No MindTouch CustomerID found.');
            return;
        }

        // prepare API request. Note: dream.out.pre is =? so it's a JSONP request
        var url = MindTouch.SITE_URL + '/@api/deki/events/support-agent/=' + customerId + '?dream.out.format=jsonp&dream.out.pre=?';
        var params = {
            limit: 50,
            include: "page,file",
            origin: MindTouch.WIDGET_NAME
        };

        j$.ajax({
            url: url,
            data: params,
            dataType: 'jsonp',
            timeout: 5000,
            success: function(data) {
            
                console.log(data);

                if (!data.events || !data.events.event) {
                    $results.text('No user history found');
                    return;
                }

                var events = data.events.event instanceof Array ? data.events.event : [data.events.event];

                $results.html('');
                j$.each(events, function(i, event) {
                    console.log('adding event');
                    console.log(event);

                    var $contents = null;
                    var label = "";
                    var $icon = null;

                    if (event['@type'] == 'page:view') {
                        label += "Viewed: ";
                        $contents = j$('<a target="_blank"></a>').attr('href', event.page["uri.ui"]).text(event.page.title);
                        $icon = j$('<i class="fa fa-file-o"></i>');


                    } else if (event['@type'] == 'user:search') {
                        label += "Searched: ";
                        $contents = j$('<a target="_blank"></a>').attr('href', MindTouch.URL + '/Special:Search?search=' + event.data.query).text(event.data.query);
                        $icon = j$('<i class="fa fa-search"></i>');
                    }
                    else {
                        return;
                    }
                    var dateString = (new Date(event["@datetime"])).toLocaleDateString();
                    var $date = j$('<span class="date"></span>').text(label + dateString);
                    
                    var $li = j$('<li></li>').append($icon, $contents, '<br>', $date);
                    $results.append($li);
                });
            },

            error: function(){
                $results.text('Could not load user history. Check that the current user is logged in and can view USERHISTORY.');
            }
        });
    };



  return {

    defaultState : 'main',

    events: {
      'app.activated': 'start',
    },

    start: function(){
      var ticket = this.ticket();
      // set default ticket
      MindTouch.CUSTOMER_ID = ticket.requester().email();
      GeniusLink.init();
    },

  };

}());

// changes needed
// use e.currentTarget instead of $()
// do not use an anonmymous function for GeniusLink. Pull it out and make it simpler to copy/paste
